#include <JGL/JGL.h>

static std::array<Vector3, 8> cube_v {
    Vector3(1.0f,  1.0f, -1.0f),
    Vector3(1.0f, -1.0f, -1.0f),
    Vector3(1.0f,  1.0f,  1.0f),
    Vector3(1.0f, -1.0f,  1.0f),
    Vector3(-1.0f,  1.0f, -1.0f),
    Vector3(-1.0f, -1.0f, -1.0f),
    Vector3(-1.0f,  1.0f,  1.0f),
    Vector3(-1.0f, -1.0f,  1.0f)
};

std::array<unsigned int, 36> cube_ind {
    4, 2, 0,
    2, 7, 3,
    6, 5, 7,
    1, 7, 5,
    0, 3, 1,
    4, 1, 5,
    4, 6, 2,
    2, 6, 7,
    6, 4, 5,
    1, 3, 7,
    0, 2, 3,
    4, 0, 1
};

std::array<Vector3, 8> cube_vn {
    Vector3( 0.816f,  0.408f, -0.408f),
    Vector3( 0.333f, -0.667f, -0.667f),
    Vector3( 0.333f,  0.667f,  0.667f),
    Vector3( 0.816f, -0.408f,  0.408f),
    Vector3(-0.333f,  0.667f, -0.667f),
    Vector3(-0.816f, -0.408f, -0.408f),
    Vector3(-0.816f,  0.408f,  0.408f),
    Vector3(-0.333f, -0.667f,  0.667f)
};

std::array<Vector2, 4> square_v { Vector2(0, 0), {1, 0}, {1, -1}, {0, -1} };
std::array<GLfloat, 3> square_vn {0, 0, 1};

void JGL::ShapeCache::Init() {
    if (!cube_vertex_data)
        cube_vertex_data = new VRamList(cube_v.data(), cube_v.size());

    if (!cube_index_data)
        cube_index_data = new VRamList(cube_ind.data(), cube_ind.size());

    if (!cube_normal_data)
        cube_normal_data = new VRamList(cube_vn.data(), cube_vn.size());

    if (!square_origin_topleft_vertex_data)
        square_origin_topleft_vertex_data = new VRamList(square_v.data(), square_v.size());

    if (!j2d_default_normal_data)
        j2d_default_normal_data = new VRamList(square_vn.data(), square_vn.size());
}